/*
 * msgQueue.h
 *
 * Created: 13/05/2013 17:28:47
 *  Author: Jordi
 */ 


#ifndef MSGQUEUE_H_
#define MSGQUEUE_H_

#include "asf/thirdparty/freertos/freertos-7.0.0/source/include/FreeRTOS.h"
#include "asf/thirdparty/freertos/freertos-7.0.0/source/include/queue.h"


 typedef struct {
	 uint8_t size;
	 char target[5];
	 char content[PAYLOAD_SIZE];
	 } nrf_frame_t;
	 
typedef struct {
	uint8_t padding[CSP_PADDING_BYTES - 4 * sizeof(uint8_t)];
	uint8_t dest;
	uint8_t len;
	uint8_t len_rx;
	uint8_t retries;
	uint16_t length; // length of data
	csp_id_t id;
	union {
		uint8_t data[0];
		uint16_t data16[0];
		uint32_t data32[0];
	};
	  } nrf_csp_frame_t;

 extern xQueueHandle rxQueue;
 extern xQueueHandle txQueue;
 
 char initMsgQueues(uint8_t txSize, uint8_t rxSize);



#endif /* MSGQUEUE_H_ */