/*
 * user_interrupts.c
 *
 * Created: 04/04/2013 14:32:48
 *  Author: Jordi
 */

//#include "user_interrupts.h"

#include "FreeRTOS.h"
#include "semphr.h"
#include <asf.h>
#include <nrf24l01.h>

#define EIC_RADIO_1 (&AVR32_EIC)
 
 xSemaphoreHandle semaphoreRadioEvent = NULL;
 //xSemaphoreHandle mutexUART = NULL;
 uint8_t gstatus;
 
eic_options_t nrf24_irq_eic = {.eic_async = EIC_ASYNCH_MODE,
								   .eic_edge = EIC_EDGE_FALLING_EDGE,
							       .eic_filter = EIC_FILTER_ENABLED,
							       .eic_level = EIC_LEVEL_LOW_LEVEL,
							       .eic_line = EXT_INT2, 
							       .eic_mode = EIC_MODE_EDGE_TRIGGERED};

ISR(radio_irq_handler,1,AVR32_INTC_INTLEV_INT0){
	//gpio_toggle_pin(LED3_GPIO);
	//gpio_toggle_pin(LED0_GPIO);
	xSemaphoreGiveFromISR(semaphoreRadioEvent,NULL);
	gstatus = nrf24_statusRead();
	eic_clear_interrupt_line(EIC_RADIO_1,EXT_INT2);
}

void extint_pin_setup(){
	
static const gpio_map_t extint_gpio_map = {{AVR32_EIC_EXTINT_2_PIN, AVR32_EIC_EXTINT_2_FUNCTION}};
    
	gpio_enable_pin_pull_up(AVR32_EIC_EXTINT_2_PIN); 
    gpio_enable_module(extint_gpio_map,sizeof(extint_gpio_map)/sizeof(extint_gpio_map[0]));
	
}							

void init_ext(){
    //sysclk_enable_peripheral_clock(EIC_RADIO_1);
	
	extint_pin_setup();
	INTC_register_interrupt (&radio_irq_handler,AVR32_EIC_IRQ_2,AVR32_INTC_INTLEV_INT0);
	
	eic_init (EIC_RADIO_1, &nrf24_irq_eic, 1);
	eic_enable_interrupt_line(EIC_RADIO_1,EXT_INT2);
	eic_enable_line (EIC_RADIO_1,EXT_INT2);


}
 

